disp('Welcome to the Analytical Resolution Calculator!');
//Input of the Data declared by the producers of the Gamma Camera

L=input('Please enter the hole length L (mm)   [Default: L=58.4 mm]  ');
if length(L)==0
L=58.4; 
end;

d=input('Please enter the hole size d (mm)   [Default: d=1.78 mm]  ');
if length(d)==0
d =1.78;               
end;
 
mu = 2.16594;          //linear att. coeff. of the coll. material at used energy (mm^-1) [usually lead]

t=input('Please enter the septal thickness t (mm)   [Default: t=0.152 mm]  ');
if length(t)==0
t =0.152;              
end;

Rint=input('Please enter the intrinsic spatial resolution R_i (mm)   [Default: Rint=4.1 mm]  ');
if length(Rint)==0
Rint = 4.1;         
end;

c=input('Please enter the crystal length c (mm)   [Default: c=19 mm]  ');
if length(c)==0
c= 19;                 //crystal length (mm)
end;

Leff=L-2/mu;

b=[d/Leff ,d+ d*c/Leff, Rint]; //linear part in Rcoll and Rint
c=[b(1)^2, 2*b(1)*b(2),b(2)^2+b(3)^2]; //parameters of the analitical formula

deff('[y]=FWHM(a,x)','y=sqrt(a(1)*x.^2+a(2)*x+a(3))');

a=input('Please enter the smallest distance (mm)   ');
if length(a)==0
a=0;
end;

b=input('Please enter the largest distance (mm)   ');
if length(b)==0
b=250;
end;
x=linspace(a,b);
figure(); plot(x,FWHM(c,x),'b'); title('Analytical Resolution Curve'), xlabel('Source-Collimator distance (mm)'), ylabel('FWHM (mm)');


if ~exists('ex')
	resp=input('Do you want to compare the Analytical resolution with an Experimental Resolution curve? [Y, n]    ','s');
	if  length(resp)==0 |isequal(resp,' ')| isequal(resp,'Yes') | isequal(resp,'y') | isequal(resp,'Y')
		ex=1;
		exec('experimental_resolution_ui.sce',2);
	else
	disp('Thank you for using our progam. Have a nice day.');
        end;
else
exec('comp_resolution.sce',2)
end;
