function [fwhm,res]=calculate_fwhm(method,show,dist,file,start,stop)
// compute fwhm from data (x_i,y_i) of a given heigh
//
//
//
// opzions for method: quadratic, tempt, gauss, spline, calculate
// we recommend to use 'spline' or 'gauss'
if (argn(2)<2)
show=0;
end;
if (argn(2)<3)
dist=13;
end;
tol=[1.d-10,1.d-10,1.d-10,1000,0,100];//stopping criteria for optimization

	st2='loadmatfile '+ file  + ';';
    execstr(st2);
execstr('data=double(r'+string(dist)+');');
res=zeros(stop-start,1);
iter=1;
pixel=2.334630; // a pixel in mm
maxiter=300; tol=1e-10; //global options 
for i=start:stop
 //uncomment for data 2D plot
 //figure(1), plot(r13(i,:)), xlabel(['i= ', num2str(i)]);
 //pause(.1);
 y=data(i,:); [a,b]=max(y);
 x=(1:length(y))-b; //set the x-axis on the max
 
 
//scelta del method
select method
////
case 'gauss' then
 //first method: gaussiana y=a*exp((-(x-x_0)^2)/(2*\sigma^2))
 
deff('z=gauss(p,m)', 'z=y-(p(2)*exp(-(p(1)^2)*x.^2))');
p0=[.3,a];

[p, cost]=lsqrsolve(p0,gauss,length(y));
//[p,it,cost]=optim(p0,funz,x,y,maxiter,tol);
res(iter)=norm(cost);
if show==1
figure(1), plot(x,y,'r',x,gauss(p),'b');
end;
// its fwhm;
fwhm(iter)=2*sqrt(log(2))/abs(p(1));
////
case 'tempt' then //experimental
deff('z=tempt(p)', 'z=y-max((-p(1)*x+p(2)).*(x>0),0)+max((p(1)*x+p(2)).*(x<=0),0)');
p0=[4e2,a];

//[p,it,cost]=optim(p0,funz,x,y,maxiter,tol); 
res(iter)=cost;
if show==1
figure(2), plot(x,y,'r',x,tempt(p),'b');
end;
// its fwhm;
fwhm(iter)=(p(2)/p(1));
 case 'quadratic' then //experimental
deff('z=quadr(p)', 'z=y-(p(1)*x.^2+p(2)).*((p(1)*x.^2+p(2))>0)');


p0=[-10,a];

//[p,it,costo]=optim(p0,funz,x,y,maxiter,tol);
test(iter)=(it==maxiter); 
res(iter)=costo;
if show==1
figure(3); plot(x,y,'r',x,quadr(p),'b');
end;
//its fwhm;
fwhm(iter)= 2*sqrt(-p(2)/(2*p(1)));
////
case 'spline' then

am=a/2; //(half of the max)
N=1e5;
dk = splin(1:256,y);
yy=interp(linspace(0,256,N),(1:256),y,dk);
if show==1
figure(3); plot(x,y,'r',linspace(0,256,N)-b,yy,'b');
end;
[hj1,v1]=min(abs(yy(1:N/2)-am));
[hj2,v2]=min(abs(yy(N/2:N)-am));

fwhm(iter)=(v2-v1+N/2)/N*256;
res(iter)=(hj1)^2 + (hj2)^2;
////
case 'calculate' then

am=a/2; //(half of the max)
[h1,v1]=min(abs(y(1:b)-am));
[h2,v2]=min(abs(y(b:length(y))-am)); 
v2=v2+b-1;

// another, experimental way...
//i1=v1(1)+((v1(2)-v1(1))/(y(v1(2))-y(v1(1))))*(am-y(v1(1)));
//i2=v2(1)+((v2(2)-v2(1))/(y(v2(2))-y(v2(1))))*(am-y(v2(1)));
fwhm(iter)=(v2-v1);
res(iter)=h1^2+h2^2;

////
else 
disp('Error: unknown method!');
break;
end;

iter=iter+1;
end;
fwhm=fwhm*pixel;
if show==1
disp(' ');
disp('metodo: '+ method);
disp('distanza = '+ string(dist));
disp(' ----------------------- ');
disp('media fwhm     = '+string(mean(fwhm)));
disp('deviazione st. = '+string(std(fwhm)));
disp('deviazione //   = '+string(std(fwhm)/mean(fwhm)*100));
disp('costo medio = '+string(mean(res)));
disp(' ');
disp(' ');
end;
endfunction
