//compare the analytical and the experimental resolution, and interpolates the exp. res. with a fitting curve.
deff('y=FWHM(a,x)','y=sqrt(a(1)*x.^2+a(2)*x+a(3))');
resp=input('Was your data taken in air?    [Y, n]    ','s');
if  length(resp)==0 |isequal(resp,' ')| isequal(resp,'Yes') | isequal(resp,'y') | isequal(resp,'Y');
f0=input('What is the FWHM at 0 mm (in mm)?   ');
	if ~length(f0)
	f0=4.7;
    end;
f100=input('What is the FWHM at 100 mm (in mm)?   ');
	if ~length(f100)
	f100=6.7;
    end
d=[0, 100, distan];
fwhm=[f0, f100, f'];
cvf=sd./f*100;
cv=  [20,  20,  cvf']; //variation coefficient

//weight matrix
SD=cv*0.01.*fwhm;
Sigma=diag((SD).^-2);
// weighted least squares with Vandermonde matrix
 M(:,1)=d'.^2;
 M(:,2)=d';
 M(:,3)=1;

 b=(fwhm.^2)';
if min(cv)>0
 a=(M'*Sigma*M)\(M'*Sigma*b); //normal equation solution
else 
a=(M'*M)\(M'*b);
end
a=a';


gap=norm(fwhm-FWHM(a,d));
curves_distance=norm(FWHM(c,d)-FWHM(a,d));
resol0=FWHM(a,0);
resol100=FWHM(a,100);

execstr('fileid=mopen(''log_'+strsubst(file,'.mat','')+'.txt'',''a'');');
mputl('The 2-norm distance between the Experimental FWHM and the analytical resolution is  '+ string(gap),fileid);
mputl('Extimated Resolution at 0mm ='+string(resol0),fileid);
mputl('Extimated Resolution at 100mm ='+string(resol100),fileid)
mputl('\n ----------------------------------------------',fileid);
mclose(fileid);


dom=linspace(0,max(d)+10);

figure();  plot(d,fwhm,'*b',dom,FWHM(c,dom),'r',dom,FWHM(a,dom),'b'); ...
xlabel('Source-Collimator distance (mm)'), ylabel('FWHM (mm)'), title('analytical curve and  data interpolation'), ...
legend('FWHM data','analytical curve','interpolation'); mtlb_hold('on');
for i=1:length(distan)
   plot([distan(i),distan(i)], [f(i)-sd(i),f(i)+sd(i)],'b'); 
end
else
    fwhm=f;
    cvf=sd./f*100;
    cv= cvf; //variation coefficient 
    d=distan;
    
 dom=linspace(0,max(d)+10);
    figure(), plot(d,fwhm,'*b',dom,FWHM(c,dom),'r'), ...
xlabel('Source-Collimator distance (mm)'), ylabel('FWHM (mm)'), title('analytical curve and  data interpolation'), ...
legend('FWHM data','analytical curve'); hold on;
for i=1:length(distan)
   plot([distan(i),distan(i)], [f(i)-sd(i),f(i)+sd(i)],'b');  
end
end

//evstr(['print -dpng graph_',method,'_',strrep(file,'.mat',''),'.png']);
disp('Thank you for using our progam. Have a nice day.');
