function [a,iter,costo_finale]=optim(a0,funz,x,y,maxiter,tol) 
// calculate the optimal parameters a* with Levemberg method using the
// optimization packages in MATLAB/Octave.
// in case none of these package is available we use Gauss-Newtom method
fun=funz.f0;
f=funz;
v=ver;
obj=@(p) (fun(p)-y)*(fun(p)-y)';
if any(strcmp('Optimization Toolbox', {v.Name}))
options=optimset('TolFun', tol, 'TolX', tol,'MaxFunEvals',maxiter,'MaxIter',maxiter,'Display','off');
[a,costo]=lsqnonlin(@(p) (fun(p)-y), a0, [0,0], 2*a0,options);
costo_finale=sqrt(obj(a));
iter=1.e2;
return;
end;

if any(strcmp('optim', {v.Name}))

[f1, a] = leasqr (x, y, a0, f.F ,tol, maxiter);
costo_finale=sqrt(obj(a));
iter=1.e2;
return;
end;
a=a0;


costo=obj(a);
iter=1;
while (costo>tol & iter<maxiter)
err=(fun(a)-y);
J=[f.f1(a)' f.f2(a)'];
F=err*J;
H=J'*J;
dev=(H/F)';
a_new=a; mu=1;
  while ((obj(a_new)>=costo) & (mu>1e-8))
   a_new=a-mu*dev;
   mu=mu/2;

   end;
   a=a_new;
iter=iter+1;

costo=obj(a);
end;
costo_finale=sqrt(costo);
endfunction
