function [f,sd,residuals]=table(method,distan,file,start,stop);
// This function simply calculates several values of fhwm at the relative distance
// - using the method 'method', 
// - reading the data from the file 'file'.mat 
// - at heights i chosen from 'start' to 'stop' (usually we chose start and stop 
// taking the heights on which the response to the line source)
// 
// 
// 
it=1;//iteration counter
disp('using the chosen method to find FWHMs...')
for i=distan
exec('calculate_fwhm.sci',2);
[fwhm,res] = calculate_fwhm(method,0,i,file,start,stop);

//relative weights based on the nuber of evaluation points
if isequal(method,'spline')| isequal(method,'calculate')
res=res/2;
else
res=res/256;
end;
f(it)=mean(fwhm);
sd(it)=stdev(fwhm);
residuals(it)=mean(res);

it=it+1;
end;
disp('writing on a log file the results of the interpolation method..')

execstr('fileid=mopen(''log_'+strsubst(file,'.mat','')+'.txt'',''a'');');
mputl(' ',fileid);
mputl('method: '+ method+'     '+string(date())+' ',fileid);
mputl(' ---------------------------------------------------------------- ',fileid);
mputl(' source-collimator dist. (mm) =   '+string(distan)+' ',fileid);
mputl(' mean fwhm (mm)      =   '+string(f)+' ',fileid);
mputl(' standard deviation = '+string(sd)+'  ',fileid);
mputl(' variation coefficient (////)     = '+string(sd./f*100)+' ',fileid);
mputl(' mean cost   = '+string(residuals)+'   ',fileid);
mputl('Now we display the three means that are crucial to find the best method: ',fileid);
mputl('MEAN standard deviations = '+string(mean(sd))+' ',fileid);
mputl('MEAN v.c. (////)     = '+string(mean(sd./f)*100)+' ',fileid);
mputl('MEAN of costs = '+string(mean(residuals))+' ',fileid);
mclose(fileid);
endfunction
